=== debian/changelog ===
xalan (1.12-12) unstable; urgency=medium

  * Switch -doc package back to arch:all.

 -- William Blough <bblough@debian.org>  Thu, 23 Oct 2025 08:05:51 -0400

xalan (1.12-11) unstable; urgency=medium

  * Fix Depends

 -- William Blough <bblough@debian.org>  Wed, 22 Oct 2025 22:13:11 -0400

xalan (1.12-10) unstable; urgency=medium

  * Switch -doc package to arch:any, Closes: 1118598

 -- William Blough <bblough@debian.org>  Wed, 22 Oct 2025 20:54:21 -0400

xalan (1.12-9) unstable; urgency=medium

  * Fixes for gcc 15, Closes: 1098118
  * Bump minimum cmake version, Closes: 1113636
  * Add missed dh files
  * Install cmake and pkgconfig files with -dev
  * Update standards version (no changes)
  * Use debhelper compat 13

 -- William Blough <bblough@debian.org>  Wed, 22 Oct 2025 09:32:31 -0400

xalan (1.12-8) unstable; urgency=medium

  * Apply patch from László Böszörményi for ICU FTBFS. Closes: #1092325

 -- William Blough <bblough@debian.org>  Sat, 22 Mar 2025 14:54:18 -0400

xalan (1.12-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063249

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 06:16:10 +0000

xalan (1.12-7) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on dh-exec (>= 0.3).
    + Build-Depends: Drop dependency on essential package dpkg-dev (>= 1.16).
  * Apply multi-arch hints. + libxalan-c-doc: Add Multi-Arch: foreign.

  [ William Blough ]
  * Fix broken symlinks.  Closes: #988866

 -- William Blough <bblough@debian.org>  Fri, 30 Dec 2022 22:16:21 -0500

xalan (1.12-6) unstable; urgency=medium

  * Switch to using build dir to avoid arch naming issues. Closes: 979327

 -- William Blough <bblough@debian.org>  Wed, 06 Jan 2021 08:30:26 -0500

xalan (1.12-5) unstable; urgency=medium

  * Use DEB_HOST_GNU_TYPE instead of DEB_HOST_MULTIARCH to fix i386/i686
    confusion.  Closes: 979327

 -- William Blough <bblough@debian.org>  Tue, 05 Jan 2021 10:11:43 -0500

xalan (1.12-4) unstable; urgency=medium

  * Upload to unstable

 -- William Blough <bblough@debian.org>  Thu, 24 Dec 2020 23:23:15 -0500

xalan (1.12-3) experimental; urgency=medium

  * Fix packaging issues related to conversion to cmake. Closes: 976299
  * Update standards version to 4.5.1 (no changes)

 -- William Blough <bblough@debian.org>  Fri, 11 Dec 2020 12:24:22 -0500

xalan (1.12-2) unstable; urgency=medium

  * Fix packaging issues related to conversion to cmake. Closes: #976299

 -- William Blough <bblough@debian.org>  Fri, 11 Dec 2020 12:16:18 -0500

xalan (1.12-1) experimental; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Fix day-of-week for changelog entries 1.6-3, 1.6-2, 1.6-1.

  [ William Blough ]
  * Update watch file for move to github
  * Update upstream signing key
  * New upstream version 1.12
  * Update package names with new soname
  * Update packaging to use new build system and layout
  * Drop or refresh patches as needed
  * Add patch to install TestXSLT
  * Add upstream patch to install XalanCAPI.h
  * Remove outdated info from d/copyright
  * Update Standards-Version to 4.5.0 (no changes needed)

 -- William Blough <bblough@debian.org>  Sun, 20 Sep 2020 16:22:25 -0400
