=== debian/watch ===
version=4

opts=,\
  pgpmode=auto,\
  downloadurlmangle=s#/tag/#/download/#;s#(Xalan\-C_([\d_]+))$#$1/xalan_c-$2.tar.gz#;s#-(\d+)_(\d+)(_(\d+))?#-$1.$2#,\
  versionmangle=s#_#.#g;s#\.0$##,\
  filenamemangle=s#.*(Xalan-C_(\d+)_(\d+)_(\d+))#xalan_c-$2.$3.tar.gz# \
  https://github.com/apache/xalan-c/tags .*/releases/tag/Xalan\-C_([\d_]+)

#TODO figure out a cleaner way to write these rules
